/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Indexes;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreValuelist.TCoreValuelistPath;
import de.ship.db.tables.TCoreValueparam.TCoreValueparamPath;
import de.ship.db.tables.records.TCoreValueRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreValue extends TableImpl<TCoreValueRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_value</code>
     */
    public static final TCoreValue T_CORE_VALUE = new TCoreValue();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreValueRecord> getRecordType() {
        return TCoreValueRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_value.pk_core_value</code>.
     */
    public final TableField<TCoreValueRecord, Integer> PK_CORE_VALUE = createField(DSL.name("pk_core_value"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_core_value.fk_value_valuelist</code>.
     */
    public final TableField<TCoreValueRecord, Integer> FK_VALUE_VALUELIST = createField(DSL.name("fk_value_valuelist"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_core_value.varvalue</code>. numerical
     * representation of this value
     */
    public final TableField<TCoreValueRecord, Integer> VARVALUE = createField(DSL.name("varvalue"), SQLDataType.INTEGER.nullable(false), this, "numerical representation of this value");

    /**
     * The column <code>common_dd.t_core_value.value_order</code>. order when
     * displaying this value in a list
     */
    public final TableField<TCoreValueRecord, Integer> VALUE_ORDER = createField(DSL.name("value_order"), SQLDataType.INTEGER.nullable(false), this, "order when displaying this value in a list");

    /**
     * The column <code>common_dd.t_core_value.lastchange</code>.
     */
    public final TableField<TCoreValueRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    private TCoreValue(Name alias, Table<TCoreValueRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreValue(Name alias, Table<TCoreValueRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_value</code> table reference
     */
    public TCoreValue(String alias) {
        this(DSL.name(alias), T_CORE_VALUE);
    }

    /**
     * Create an aliased <code>common_dd.t_core_value</code> table reference
     */
    public TCoreValue(Name alias) {
        this(alias, T_CORE_VALUE);
    }

    /**
     * Create a <code>common_dd.t_core_value</code> table reference
     */
    public TCoreValue() {
        this(DSL.name("t_core_value"), null);
    }

    public <O extends Record> TCoreValue(Table<O> path, ForeignKey<O, TCoreValueRecord> childPath, InverseForeignKey<O, TCoreValueRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_VALUE);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreValuePath extends TCoreValue implements Path<TCoreValueRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreValuePath(Table<O> path, ForeignKey<O, TCoreValueRecord> childPath, InverseForeignKey<O, TCoreValueRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreValuePath(Name alias, Table<TCoreValueRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreValuePath as(String alias) {
            return new TCoreValuePath(DSL.name(alias), this);
        }

        @Override
        public TCoreValuePath as(Name alias) {
            return new TCoreValuePath(alias, this);
        }

        @Override
        public TCoreValuePath as(Table<?> alias) {
            return new TCoreValuePath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public List<Index> getIndexes() {
        return Arrays.asList(Indexes.IDX_CORE_VALUEPARAM_FK_VALUE_VALUELIST);
    }

    @Override
    public Identity<TCoreValueRecord, Integer> getIdentity() {
        return (Identity<TCoreValueRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreValueRecord> getPrimaryKey() {
        return Keys.PK_CORE_VALUE;
    }

    @Override
    public List<UniqueKey<TCoreValueRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_VARVALUE);
    }

    @Override
    public List<ForeignKey<TCoreValueRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_VALUE__FK_VALUE_VALUELIST);
    }

    private transient TCoreValuelistPath _tCoreValuelist;

    /**
     * Get the implicit join path to the <code>common_dd.t_core_valuelist</code>
     * table.
     */
    public TCoreValuelistPath tCoreValuelist() {
        if (_tCoreValuelist == null)
            _tCoreValuelist = new TCoreValuelistPath(this, Keys.T_CORE_VALUE__FK_VALUE_VALUELIST, null);

        return _tCoreValuelist;
    }

    private transient TCoreValueparamPath _tCoreValueparam;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_valueparam</code> table
     */
    public TCoreValueparamPath tCoreValueparam() {
        if (_tCoreValueparam == null)
            _tCoreValueparam = new TCoreValueparamPath(this, null, Keys.T_CORE_VALUEPARAM__FK_VALUEPARAM_VALUE.getInverseKey());

        return _tCoreValueparam;
    }

    @Override
    public TCoreValue as(String alias) {
        return new TCoreValue(DSL.name(alias), this);
    }

    @Override
    public TCoreValue as(Name alias) {
        return new TCoreValue(alias, this);
    }

    @Override
    public TCoreValue as(Table<?> alias) {
        return new TCoreValue(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreValue rename(String name) {
        return new TCoreValue(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreValue rename(Name name) {
        return new TCoreValue(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreValue rename(Table<?> name) {
        return new TCoreValue(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreValue where(Condition condition) {
        return new TCoreValue(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreValue where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreValue where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreValue where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreValue where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreValue where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreValue where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreValue where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreValue whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreValue whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
